/* tracker-remote.c generated by valac 0.54.6, the Vala compiler
 * generated from tracker-remote.vala, do not modify */

/*
 * Copyright (C) 2016 Carlos Garnacho <carlosg@gnome.org>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA.
 *
 * Author: Carlos Garnacho <carlosg@gnome.org>
 */

#include "tracker-remote-soup2.h"
#include "libtracker-sparql/tracker-sparql.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <glib-object.h>
#include <libsoup/soup.h>

#define TRACKER_REMOTE_CONNECTION_XML_TYPE "application/sparql-results+xml"
#define TRACKER_REMOTE_CONNECTION_JSON_TYPE "application/sparql-results+json"
#define TRACKER_REMOTE_CONNECTION_USER_AGENT "Tracker/" PACKAGE_VERSION " (https://gitlab.gnome.org/GNOME/tracker/issues/; tracker-list@lists.g" \
"nome.org) Tracker/" PACKAGE_VERSION

enum  {
	TRACKER_REMOTE_CONNECTION_0_PROPERTY,
	TRACKER_REMOTE_CONNECTION_NUM_PROPERTIES
};
static GParamSpec* tracker_remote_connection_properties[TRACKER_REMOTE_CONNECTION_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_SoupMessageHeaders_free0(var) ((var == NULL) ? NULL : (var = (_vala_SoupMessageHeaders_free (var), NULL)))
#define __vala_SoupBuffer_free0(var) ((var == NULL) ? NULL : (var = (_vala_SoupBuffer_free (var), NULL)))
typedef struct _TrackerRemoteConnectionQueryAsyncData TrackerRemoteConnectionQueryAsyncData;
typedef struct _TrackerRemoteConnectionCloseAsyncData TrackerRemoteConnectionCloseAsyncData;

struct _TrackerRemoteConnectionQueryAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	TrackerRemoteConnection* self;
	gchar* sparql;
	GCancellable* cancellable;
	TrackerSparqlCursor* result;
	SoupMessage* message;
	SoupMessage* _tmp0_;
	SoupSession* _tmp1_;
	SoupMessage* _tmp2_;
	GInputStream* _tmp3_;
	GInputStream* _tmp4_;
	TrackerSparqlCursor* _tmp5_;
	SoupMessage* _tmp6_;
	SoupMessage* _tmp7_;
	SoupMessageBody* _tmp8_;
	SoupBuffer* _tmp9_;
	SoupBuffer* _tmp10_;
	guint8* _tmp11_;
	gint _tmp11__length1;
	TrackerSparqlCursor* _tmp12_;
	TrackerSparqlCursor* _tmp13_;
	TrackerSparqlCursor* _tmp14_;
	GError* _inner_error0_;
};

struct _TrackerRemoteConnectionCloseAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	TrackerRemoteConnection* self;
	gboolean result;
};

static gpointer tracker_remote_connection_parent_class = NULL;

static SoupMessage* tracker_remote_connection_create_request (TrackerRemoteConnection* self,
                                                       const gchar* sparql);
static SoupMessageHeaders* _vala_SoupMessageHeaders_copy (SoupMessageHeaders* self);
static void _vala_SoupMessageHeaders_free (SoupMessageHeaders* self);
static TrackerSparqlCursor* tracker_remote_connection_create_cursor (TrackerRemoteConnection* self,
                                                              SoupMessage* message,
                                                              const gchar* document,
                                                              GError** error);
static TrackerSparqlCursor* tracker_remote_connection_real_query (TrackerSparqlConnection* base,
                                                           const gchar* sparql,
                                                           GCancellable* cancellable,
                                                           GError** error);
static void _vala_SoupBuffer_free (SoupBuffer* self);
static void tracker_remote_connection_real_query_async_data_free (gpointer _data);
static void tracker_remote_connection_real_query_async (TrackerSparqlConnection* base,
                                                 const gchar* sparql,
                                                 GCancellable* cancellable,
                                                 GAsyncReadyCallback _callback_,
                                                 gpointer _user_data_);
static gboolean tracker_remote_connection_real_query_async_co (TrackerRemoteConnectionQueryAsyncData* _data_);
static void tracker_remote_connection_query_async_ready (GObject* source_object,
                                                  GAsyncResult* _res_,
                                                  gpointer _user_data_);
static void tracker_remote_connection_real_close (TrackerSparqlConnection* base);
static void tracker_remote_connection_real_close_async_data_free (gpointer _data);
static void tracker_remote_connection_real_close_async (TrackerSparqlConnection* base,
                                                 GAsyncReadyCallback _callback_,
                                                 gpointer _user_data_);
static gboolean tracker_remote_connection_real_close_async_co (TrackerRemoteConnectionCloseAsyncData* _data_);
static void tracker_remote_connection_finalize (GObject * obj);
static GType tracker_remote_connection_get_type_once (void);

TrackerRemoteConnection*
tracker_remote_connection_construct (GType object_type,
                                     const gchar* base_uri)
{
	TrackerRemoteConnection * self = NULL;
	gchar* _tmp0_;
	SoupSession* _tmp1_;
#line 33 "../src/libtracker-sparql/remote/tracker-remote.vala"
	g_return_val_if_fail (base_uri != NULL, NULL);
#line 34 "../src/libtracker-sparql/remote/tracker-remote.vala"
	self = (TrackerRemoteConnection*) g_object_new (object_type, NULL);
#line 35 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp0_ = g_strdup (base_uri);
#line 35 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_g_free0 (self->_base_uri);
#line 35 "../src/libtracker-sparql/remote/tracker-remote.vala"
	self->_base_uri = _tmp0_;
#line 36 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp1_ = soup_session_new ();
#line 36 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_g_object_unref0 (self->_session);
#line 36 "../src/libtracker-sparql/remote/tracker-remote.vala"
	self->_session = _tmp1_;
#line 33 "../src/libtracker-sparql/remote/tracker-remote.vala"
	return self;
#line 148 "tracker-remote.c"
}

TrackerRemoteConnection*
tracker_remote_connection_new (const gchar* base_uri)
{
#line 33 "../src/libtracker-sparql/remote/tracker-remote.vala"
	return tracker_remote_connection_construct (TRACKER_REMOTE_TYPE_CONNECTION, base_uri);
#line 156 "tracker-remote.c"
}

static SoupMessageHeaders*
_vala_SoupMessageHeaders_copy (SoupMessageHeaders* self)
{
#line 43 "../src/libtracker-sparql/remote/tracker-remote.vala"
	return g_boxed_copy (soup_message_headers_get_type (), self);
#line 164 "tracker-remote.c"
}

static gpointer
__vala_SoupMessageHeaders_copy0 (gpointer self)
{
#line 43 "../src/libtracker-sparql/remote/tracker-remote.vala"
	return self ? _vala_SoupMessageHeaders_copy (self) : NULL;
#line 172 "tracker-remote.c"
}

static void
_vala_SoupMessageHeaders_free (SoupMessageHeaders* self)
{
#line 52 "../src/libtracker-sparql/remote/tracker-remote.vala"
	g_boxed_free (soup_message_headers_get_type (), self);
#line 180 "tracker-remote.c"
}

static SoupMessage*
tracker_remote_connection_create_request (TrackerRemoteConnection* self,
                                          const gchar* sparql)
{
	gchar* uri = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	SoupMessage* message = NULL;
	SoupMessage* _tmp5_;
	SoupMessageHeaders* headers = NULL;
	SoupMessageHeaders* _tmp6_;
	SoupMessageHeaders* _tmp7_;
	SoupMessage* result = NULL;
#line 39 "../src/libtracker-sparql/remote/tracker-remote.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 39 "../src/libtracker-sparql/remote/tracker-remote.vala"
	g_return_val_if_fail (sparql != NULL, NULL);
#line 40 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp0_ = self->_base_uri;
#line 40 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp1_ = g_strconcat (_tmp0_, "?query=", NULL);
#line 40 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp2_ = _tmp1_;
#line 40 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp3_ = g_strconcat (_tmp2_, sparql, NULL);
#line 40 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp4_ = _tmp3_;
#line 40 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_g_free0 (_tmp2_);
#line 40 "../src/libtracker-sparql/remote/tracker-remote.vala"
	uri = _tmp4_;
#line 41 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp5_ = soup_message_new ("GET", uri);
#line 41 "../src/libtracker-sparql/remote/tracker-remote.vala"
	message = _tmp5_;
#line 43 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp6_ = message->request_headers;
#line 43 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp7_ = __vala_SoupMessageHeaders_copy0 (_tmp6_);
#line 43 "../src/libtracker-sparql/remote/tracker-remote.vala"
	headers = _tmp7_;
#line 48 "../src/libtracker-sparql/remote/tracker-remote.vala"
	soup_message_headers_append (headers, "User-Agent", TRACKER_REMOTE_CONNECTION_USER_AGENT);
#line 49 "../src/libtracker-sparql/remote/tracker-remote.vala"
	soup_message_headers_append (headers, "Accept", TRACKER_REMOTE_CONNECTION_JSON_TYPE);
#line 50 "../src/libtracker-sparql/remote/tracker-remote.vala"
	soup_message_headers_append (headers, "Accept", TRACKER_REMOTE_CONNECTION_XML_TYPE);
#line 52 "../src/libtracker-sparql/remote/tracker-remote.vala"
	result = message;
#line 52 "../src/libtracker-sparql/remote/tracker-remote.vala"
	__vala_SoupMessageHeaders_free0 (headers);
#line 52 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_g_free0 (uri);
#line 52 "../src/libtracker-sparql/remote/tracker-remote.vala"
	return result;
#line 241 "tracker-remote.c"
}

static TrackerSparqlCursor*
tracker_remote_connection_create_cursor (TrackerRemoteConnection* self,
                                         SoupMessage* message,
                                         const gchar* document,
                                         GError** error)
{
	guint status_code = 0U;
	guint _tmp0_;
	guint _tmp1_;
	SoupMessageHeaders* headers = NULL;
	SoupMessageHeaders* _tmp2_;
	SoupMessageHeaders* _tmp3_;
	gchar* content_type = NULL;
	SoupMessageHeaders* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	glong length = 0L;
	gint _tmp8_;
	gint _tmp9_;
	const gchar* _tmp10_;
	GError* _inner_error0_ = NULL;
	TrackerSparqlCursor* result = NULL;
#line 55 "../src/libtracker-sparql/remote/tracker-remote.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 55 "../src/libtracker-sparql/remote/tracker-remote.vala"
	g_return_val_if_fail (message != NULL, NULL);
#line 55 "../src/libtracker-sparql/remote/tracker-remote.vala"
	g_return_val_if_fail (document != NULL, NULL);
#line 57 "../src/libtracker-sparql/remote/tracker-remote.vala"
	g_object_get (message, "status-code", &_tmp0_, NULL);
#line 57 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp1_ = _tmp0_;
#line 57 "../src/libtracker-sparql/remote/tracker-remote.vala"
	status_code = _tmp1_;
#line 58 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp2_ = message->response_headers;
#line 58 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp3_ = __vala_SoupMessageHeaders_copy0 (_tmp2_);
#line 58 "../src/libtracker-sparql/remote/tracker-remote.vala"
	headers = _tmp3_;
#line 64 "../src/libtracker-sparql/remote/tracker-remote.vala"
	if (status_code != ((guint) SOUP_STATUS_OK)) {
#line 286 "tracker-remote.c"
		GError* _tmp4_;
#line 65 "../src/libtracker-sparql/remote/tracker-remote.vala"
		_tmp4_ = g_error_new (TRACKER_SPARQL_ERROR, TRACKER_SPARQL_ERROR_UNSUPPORTED, "Unhandled status code %u, document is: %s", status_code, document);
#line 65 "../src/libtracker-sparql/remote/tracker-remote.vala"
		_inner_error0_ = _tmp4_;
#line 65 "../src/libtracker-sparql/remote/tracker-remote.vala"
		g_propagate_error (error, _inner_error0_);
#line 65 "../src/libtracker-sparql/remote/tracker-remote.vala"
		__vala_SoupMessageHeaders_free0 (headers);
#line 65 "../src/libtracker-sparql/remote/tracker-remote.vala"
		return NULL;
#line 298 "tracker-remote.c"
	}
#line 69 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp5_ = headers;
#line 69 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp6_ = soup_message_headers_get_content_type (_tmp5_, NULL);
#line 69 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp7_ = g_strdup (_tmp6_);
#line 69 "../src/libtracker-sparql/remote/tracker-remote.vala"
	content_type = _tmp7_;
#line 70 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp8_ = strlen (document);
#line 70 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp9_ = _tmp8_;
#line 70 "../src/libtracker-sparql/remote/tracker-remote.vala"
	length = (glong) _tmp9_;
#line 72 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp10_ = content_type;
#line 72 "../src/libtracker-sparql/remote/tracker-remote.vala"
	if (g_strcmp0 (_tmp10_, TRACKER_REMOTE_CONNECTION_JSON_TYPE) == 0) {
#line 318 "tracker-remote.c"
		TrackerRemoteJsonCursor* _tmp11_ = NULL;
		TrackerRemoteJsonCursor* _tmp12_;
		TrackerRemoteJsonCursor* _tmp13_;
#line 73 "../src/libtracker-sparql/remote/tracker-remote.vala"
		_tmp12_ = tracker_remote_json_cursor_new (document, length, &_inner_error0_);
#line 73 "../src/libtracker-sparql/remote/tracker-remote.vala"
		_tmp11_ = _tmp12_;
#line 73 "../src/libtracker-sparql/remote/tracker-remote.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 73 "../src/libtracker-sparql/remote/tracker-remote.vala"
			g_propagate_error (error, _inner_error0_);
#line 73 "../src/libtracker-sparql/remote/tracker-remote.vala"
			_g_free0 (content_type);
#line 73 "../src/libtracker-sparql/remote/tracker-remote.vala"
			__vala_SoupMessageHeaders_free0 (headers);
#line 73 "../src/libtracker-sparql/remote/tracker-remote.vala"
			return NULL;
#line 336 "tracker-remote.c"
		}
#line 73 "../src/libtracker-sparql/remote/tracker-remote.vala"
		_tmp13_ = _tmp11_;
#line 73 "../src/libtracker-sparql/remote/tracker-remote.vala"
		_tmp11_ = NULL;
#line 73 "../src/libtracker-sparql/remote/tracker-remote.vala"
		result = (TrackerSparqlCursor*) _tmp13_;
#line 73 "../src/libtracker-sparql/remote/tracker-remote.vala"
		_g_object_unref0 (_tmp11_);
#line 73 "../src/libtracker-sparql/remote/tracker-remote.vala"
		_g_free0 (content_type);
#line 73 "../src/libtracker-sparql/remote/tracker-remote.vala"
		__vala_SoupMessageHeaders_free0 (headers);
#line 73 "../src/libtracker-sparql/remote/tracker-remote.vala"
		return result;
#line 352 "tracker-remote.c"
	} else {
		const gchar* _tmp14_;
#line 74 "../src/libtracker-sparql/remote/tracker-remote.vala"
		_tmp14_ = content_type;
#line 74 "../src/libtracker-sparql/remote/tracker-remote.vala"
		if (g_strcmp0 (_tmp14_, TRACKER_REMOTE_CONNECTION_XML_TYPE) == 0) {
#line 359 "tracker-remote.c"
			TrackerRemoteXmlCursor* _tmp15_ = NULL;
			TrackerRemoteXmlCursor* _tmp16_;
			TrackerRemoteXmlCursor* _tmp17_;
#line 75 "../src/libtracker-sparql/remote/tracker-remote.vala"
			_tmp16_ = tracker_remote_xml_cursor_new (document, length, &_inner_error0_);
#line 75 "../src/libtracker-sparql/remote/tracker-remote.vala"
			_tmp15_ = _tmp16_;
#line 75 "../src/libtracker-sparql/remote/tracker-remote.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 75 "../src/libtracker-sparql/remote/tracker-remote.vala"
				g_propagate_error (error, _inner_error0_);
#line 75 "../src/libtracker-sparql/remote/tracker-remote.vala"
				_g_free0 (content_type);
#line 75 "../src/libtracker-sparql/remote/tracker-remote.vala"
				__vala_SoupMessageHeaders_free0 (headers);
#line 75 "../src/libtracker-sparql/remote/tracker-remote.vala"
				return NULL;
#line 377 "tracker-remote.c"
			}
#line 75 "../src/libtracker-sparql/remote/tracker-remote.vala"
			_tmp17_ = _tmp15_;
#line 75 "../src/libtracker-sparql/remote/tracker-remote.vala"
			_tmp15_ = NULL;
#line 75 "../src/libtracker-sparql/remote/tracker-remote.vala"
			result = (TrackerSparqlCursor*) _tmp17_;
#line 75 "../src/libtracker-sparql/remote/tracker-remote.vala"
			_g_object_unref0 (_tmp15_);
#line 75 "../src/libtracker-sparql/remote/tracker-remote.vala"
			_g_free0 (content_type);
#line 75 "../src/libtracker-sparql/remote/tracker-remote.vala"
			__vala_SoupMessageHeaders_free0 (headers);
#line 75 "../src/libtracker-sparql/remote/tracker-remote.vala"
			return result;
#line 393 "tracker-remote.c"
		} else {
			const gchar* _tmp18_;
			GError* _tmp19_;
#line 77 "../src/libtracker-sparql/remote/tracker-remote.vala"
			_tmp18_ = content_type;
#line 77 "../src/libtracker-sparql/remote/tracker-remote.vala"
			_tmp19_ = g_error_new (TRACKER_SPARQL_ERROR, TRACKER_SPARQL_ERROR_UNSUPPORTED, "Unknown content type '%s', document is: %s", _tmp18_, document);
#line 77 "../src/libtracker-sparql/remote/tracker-remote.vala"
			_inner_error0_ = _tmp19_;
#line 77 "../src/libtracker-sparql/remote/tracker-remote.vala"
			g_propagate_error (error, _inner_error0_);
#line 77 "../src/libtracker-sparql/remote/tracker-remote.vala"
			_g_free0 (content_type);
#line 77 "../src/libtracker-sparql/remote/tracker-remote.vala"
			__vala_SoupMessageHeaders_free0 (headers);
#line 77 "../src/libtracker-sparql/remote/tracker-remote.vala"
			return NULL;
#line 411 "tracker-remote.c"
		}
	}
}

static void
_vala_SoupBuffer_free (SoupBuffer* self)
{
#line 94 "../src/libtracker-sparql/remote/tracker-remote.vala"
	g_boxed_free (soup_buffer_get_type (), self);
#line 421 "tracker-remote.c"
}

static TrackerSparqlCursor*
tracker_remote_connection_real_query (TrackerSparqlConnection* base,
                                      const gchar* sparql,
                                      GCancellable* cancellable,
                                      GError** error)
{
	TrackerRemoteConnection * self;
	SoupMessage* message = NULL;
	SoupMessage* _tmp0_;
	SoupSession* _tmp1_;
	SoupMessage* _tmp2_;
	gboolean _tmp3_ = FALSE;
	TrackerSparqlCursor* _tmp5_ = NULL;
	SoupMessage* _tmp6_;
	SoupMessage* _tmp7_;
	SoupMessageBody* _tmp8_;
	SoupBuffer* _tmp9_;
	SoupBuffer* _tmp10_;
	guint8* _tmp11_;
	gint _tmp11__length1;
	TrackerSparqlCursor* _tmp12_;
	TrackerSparqlCursor* _tmp13_;
	TrackerSparqlCursor* _tmp14_;
	GError* _inner_error0_ = NULL;
	TrackerSparqlCursor* result = NULL;
#line 81 "../src/libtracker-sparql/remote/tracker-remote.vala"
	self = (TrackerRemoteConnection*) base;
#line 81 "../src/libtracker-sparql/remote/tracker-remote.vala"
	g_return_val_if_fail (sparql != NULL, NULL);
#line 82 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp0_ = tracker_remote_connection_create_request (self, sparql);
#line 82 "../src/libtracker-sparql/remote/tracker-remote.vala"
	message = _tmp0_;
#line 85 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp1_ = self->_session;
#line 85 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp2_ = message;
#line 85 "../src/libtracker-sparql/remote/tracker-remote.vala"
	soup_session_send_message (_tmp1_, _tmp2_);
#line 90 "../src/libtracker-sparql/remote/tracker-remote.vala"
	if (cancellable != NULL) {
#line 90 "../src/libtracker-sparql/remote/tracker-remote.vala"
		_tmp3_ = g_cancellable_is_cancelled (cancellable);
#line 467 "tracker-remote.c"
	} else {
#line 90 "../src/libtracker-sparql/remote/tracker-remote.vala"
		_tmp3_ = FALSE;
#line 471 "tracker-remote.c"
	}
#line 90 "../src/libtracker-sparql/remote/tracker-remote.vala"
	if (_tmp3_) {
#line 475 "tracker-remote.c"
		GError* _tmp4_;
#line 91 "../src/libtracker-sparql/remote/tracker-remote.vala"
		_tmp4_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_CANCELLED, "Operation was cancelled");
#line 91 "../src/libtracker-sparql/remote/tracker-remote.vala"
		_inner_error0_ = _tmp4_;
#line 91 "../src/libtracker-sparql/remote/tracker-remote.vala"
		g_propagate_error (error, _inner_error0_);
#line 91 "../src/libtracker-sparql/remote/tracker-remote.vala"
		_g_object_unref0 (message);
#line 91 "../src/libtracker-sparql/remote/tracker-remote.vala"
		return NULL;
#line 487 "tracker-remote.c"
	}
#line 94 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp6_ = message;
#line 94 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp7_ = message;
#line 94 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp8_ = _tmp7_->response_body;
#line 94 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp9_ = soup_message_body_flatten (_tmp8_);
#line 94 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp10_ = _tmp9_;
#line 94 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp11_ = _tmp10_->data;
#line 94 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp11__length1 = _tmp10_->length;
#line 94 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp12_ = tracker_remote_connection_create_cursor (self, _tmp6_, (const gchar*) _tmp11_, &_inner_error0_);
#line 94 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp13_ = _tmp12_;
#line 94 "../src/libtracker-sparql/remote/tracker-remote.vala"
	__vala_SoupBuffer_free0 (_tmp10_);
#line 94 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp5_ = _tmp13_;
#line 94 "../src/libtracker-sparql/remote/tracker-remote.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 94 "../src/libtracker-sparql/remote/tracker-remote.vala"
		g_propagate_error (error, _inner_error0_);
#line 94 "../src/libtracker-sparql/remote/tracker-remote.vala"
		_g_object_unref0 (message);
#line 94 "../src/libtracker-sparql/remote/tracker-remote.vala"
		return NULL;
#line 519 "tracker-remote.c"
	}
#line 94 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp14_ = _tmp5_;
#line 94 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp5_ = NULL;
#line 94 "../src/libtracker-sparql/remote/tracker-remote.vala"
	result = _tmp14_;
#line 94 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_g_object_unref0 (_tmp5_);
#line 94 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_g_object_unref0 (message);
#line 94 "../src/libtracker-sparql/remote/tracker-remote.vala"
	return result;
#line 533 "tracker-remote.c"
}

static void
tracker_remote_connection_real_query_async_data_free (gpointer _data)
{
	TrackerRemoteConnectionQueryAsyncData* _data_;
	_data_ = _data;
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_g_free0 (_data_->sparql);
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_g_object_unref0 (_data_->result);
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	g_slice_free (TrackerRemoteConnectionQueryAsyncData, _data_);
#line 551 "tracker-remote.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	return self ? g_object_ref (self) : NULL;
#line 559 "tracker-remote.c"
}

static void
tracker_remote_connection_real_query_async (TrackerSparqlConnection* base,
                                            const gchar* sparql,
                                            GCancellable* cancellable,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_)
{
	TrackerRemoteConnection * self;
	TrackerRemoteConnectionQueryAsyncData* _data_;
	TrackerRemoteConnection* _tmp0_;
	gchar* _tmp1_;
	GCancellable* _tmp2_;
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	g_return_if_fail (sparql != NULL);
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	self = (TrackerRemoteConnection*) base;
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_ = g_slice_new0 (TrackerRemoteConnectionQueryAsyncData);
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	g_task_set_task_data (_data_->_async_result, _data_, tracker_remote_connection_real_query_async_data_free);
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_->self = _tmp0_;
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp1_ = g_strdup (sparql);
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_g_free0 (_data_->sparql);
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_->sparql = _tmp1_;
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_->cancellable = _tmp2_;
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	tracker_remote_connection_real_query_async_co (_data_);
#line 602 "tracker-remote.c"
}

static TrackerSparqlCursor*
tracker_remote_connection_query_finish (TrackerSparqlConnection* base,
                                        GAsyncResult* _res_,
                                        GError** error)
{
	TrackerSparqlCursor* result;
	TrackerRemoteConnectionQueryAsyncData* _data_;
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	if (NULL == _data_) {
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
		return NULL;
#line 618 "tracker-remote.c"
	}
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	result = _data_->result;
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_->result = NULL;
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	return result;
#line 626 "tracker-remote.c"
}

static void
tracker_remote_connection_query_async_ready (GObject* source_object,
                                             GAsyncResult* _res_,
                                             gpointer _user_data_)
{
	TrackerRemoteConnectionQueryAsyncData* _data_;
#line 104 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_ = _user_data_;
#line 104 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_->_source_object_ = source_object;
#line 104 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_->_res_ = _res_;
#line 104 "../src/libtracker-sparql/remote/tracker-remote.vala"
	tracker_remote_connection_real_query_async_co (_data_);
#line 643 "tracker-remote.c"
}

static gboolean
tracker_remote_connection_real_query_async_co (TrackerRemoteConnectionQueryAsyncData* _data_)
{
#line 100 "../src/libtracker-sparql/remote/tracker-remote.vala"
	switch (_data_->_state_) {
#line 100 "../src/libtracker-sparql/remote/tracker-remote.vala"
		case 0:
#line 653 "tracker-remote.c"
		goto _state_0;
#line 100 "../src/libtracker-sparql/remote/tracker-remote.vala"
		case 1:
#line 657 "tracker-remote.c"
		goto _state_1;
		default:
#line 100 "../src/libtracker-sparql/remote/tracker-remote.vala"
		g_assert_not_reached ();
#line 662 "tracker-remote.c"
	}
	_state_0:
#line 101 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_->_tmp0_ = tracker_remote_connection_create_request (_data_->self, _data_->sparql);
#line 101 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_->message = _data_->_tmp0_;
#line 104 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_->_tmp1_ = _data_->self->_session;
#line 104 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_->_tmp2_ = _data_->message;
#line 104 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_->_state_ = 1;
#line 104 "../src/libtracker-sparql/remote/tracker-remote.vala"
	soup_session_send_async (_data_->_tmp1_, _data_->_tmp2_, _data_->cancellable, tracker_remote_connection_query_async_ready, _data_);
#line 104 "../src/libtracker-sparql/remote/tracker-remote.vala"
	return FALSE;
#line 679 "tracker-remote.c"
	_state_1:
#line 104 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_->_tmp3_ = soup_session_send_finish (_data_->_tmp1_, _data_->_res_, &_data_->_inner_error0_);
#line 104 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_->_tmp4_ = _data_->_tmp3_;
#line 104 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_g_object_unref0 (_data_->_tmp4_);
#line 104 "../src/libtracker-sparql/remote/tracker-remote.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 104 "../src/libtracker-sparql/remote/tracker-remote.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 104 "../src/libtracker-sparql/remote/tracker-remote.vala"
		_g_object_unref0 (_data_->message);
#line 104 "../src/libtracker-sparql/remote/tracker-remote.vala"
		g_object_unref (_data_->_async_result);
#line 104 "../src/libtracker-sparql/remote/tracker-remote.vala"
		return FALSE;
#line 697 "tracker-remote.c"
	}
#line 105 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_->_tmp6_ = _data_->message;
#line 105 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_->_tmp7_ = _data_->message;
#line 105 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_->_tmp8_ = _data_->_tmp7_->response_body;
#line 105 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_->_tmp9_ = soup_message_body_flatten (_data_->_tmp8_);
#line 105 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_->_tmp10_ = _data_->_tmp9_;
#line 105 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_->_tmp11_ = _data_->_tmp10_->data;
#line 105 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_->_tmp11__length1 = _data_->_tmp10_->length;
#line 105 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_->_tmp12_ = tracker_remote_connection_create_cursor (_data_->self, _data_->_tmp6_, (const gchar*) _data_->_tmp11_, &_data_->_inner_error0_);
#line 105 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_->_tmp13_ = _data_->_tmp12_;
#line 105 "../src/libtracker-sparql/remote/tracker-remote.vala"
	__vala_SoupBuffer_free0 (_data_->_tmp10_);
#line 105 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_->_tmp5_ = _data_->_tmp13_;
#line 105 "../src/libtracker-sparql/remote/tracker-remote.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 105 "../src/libtracker-sparql/remote/tracker-remote.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 105 "../src/libtracker-sparql/remote/tracker-remote.vala"
		_g_object_unref0 (_data_->message);
#line 105 "../src/libtracker-sparql/remote/tracker-remote.vala"
		g_object_unref (_data_->_async_result);
#line 105 "../src/libtracker-sparql/remote/tracker-remote.vala"
		return FALSE;
#line 731 "tracker-remote.c"
	}
#line 105 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_->_tmp14_ = _data_->_tmp5_;
#line 105 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_->_tmp5_ = NULL;
#line 105 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_->result = _data_->_tmp14_;
#line 105 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_g_object_unref0 (_data_->_tmp5_);
#line 105 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_g_object_unref0 (_data_->message);
#line 105 "../src/libtracker-sparql/remote/tracker-remote.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 105 "../src/libtracker-sparql/remote/tracker-remote.vala"
	if (_data_->_state_ != 0) {
#line 105 "../src/libtracker-sparql/remote/tracker-remote.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 105 "../src/libtracker-sparql/remote/tracker-remote.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 751 "tracker-remote.c"
		}
	}
#line 105 "../src/libtracker-sparql/remote/tracker-remote.vala"
	g_object_unref (_data_->_async_result);
#line 105 "../src/libtracker-sparql/remote/tracker-remote.vala"
	return FALSE;
#line 758 "tracker-remote.c"
}

static void
tracker_remote_connection_real_close (TrackerSparqlConnection* base)
{
	TrackerRemoteConnection * self;
#line 112 "../src/libtracker-sparql/remote/tracker-remote.vala"
	self = (TrackerRemoteConnection*) base;
#line 767 "tracker-remote.c"
}

static void
tracker_remote_connection_real_close_async_data_free (gpointer _data)
{
	TrackerRemoteConnectionCloseAsyncData* _data_;
	_data_ = _data;
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	g_slice_free (TrackerRemoteConnectionCloseAsyncData, _data_);
#line 779 "tracker-remote.c"
}

static void
tracker_remote_connection_real_close_async (TrackerSparqlConnection* base,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_)
{
	TrackerRemoteConnection * self;
	TrackerRemoteConnectionCloseAsyncData* _data_;
	TrackerRemoteConnection* _tmp0_;
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	self = (TrackerRemoteConnection*) base;
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_ = g_slice_new0 (TrackerRemoteConnectionCloseAsyncData);
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	g_task_set_task_data (_data_->_async_result, _data_, tracker_remote_connection_real_close_async_data_free);
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_->self = _tmp0_;
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	tracker_remote_connection_real_close_async_co (_data_);
#line 804 "tracker-remote.c"
}

static gboolean
tracker_remote_connection_close_finish (TrackerSparqlConnection* base,
                                        GAsyncResult* _res_,
                                        GError** error)
{
	gboolean result;
	TrackerRemoteConnectionCloseAsyncData* _data_;
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	if (NULL == _data_) {
#line 818 "tracker-remote.c"
		gboolean _tmp0_ = FALSE;
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
		return _tmp0_;
#line 822 "tracker-remote.c"
	}
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	result = _data_->result;
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	return result;
#line 828 "tracker-remote.c"
}

static gboolean
tracker_remote_connection_real_close_async_co (TrackerRemoteConnectionCloseAsyncData* _data_)
{
#line 115 "../src/libtracker-sparql/remote/tracker-remote.vala"
	switch (_data_->_state_) {
#line 115 "../src/libtracker-sparql/remote/tracker-remote.vala"
		case 0:
#line 838 "tracker-remote.c"
		goto _state_0;
		default:
#line 115 "../src/libtracker-sparql/remote/tracker-remote.vala"
		g_assert_not_reached ();
#line 843 "tracker-remote.c"
	}
	_state_0:
#line 116 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_->result = TRUE;
#line 116 "../src/libtracker-sparql/remote/tracker-remote.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 116 "../src/libtracker-sparql/remote/tracker-remote.vala"
	if (_data_->_state_ != 0) {
#line 116 "../src/libtracker-sparql/remote/tracker-remote.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 116 "../src/libtracker-sparql/remote/tracker-remote.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 856 "tracker-remote.c"
		}
	}
#line 116 "../src/libtracker-sparql/remote/tracker-remote.vala"
	g_object_unref (_data_->_async_result);
#line 116 "../src/libtracker-sparql/remote/tracker-remote.vala"
	return FALSE;
#line 863 "tracker-remote.c"
}

static void
tracker_remote_connection_class_init (TrackerRemoteConnectionClass * klass,
                                      gpointer klass_data)
{
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	tracker_remote_connection_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	((TrackerSparqlConnectionClass *) klass)->query = (TrackerSparqlCursor* (*) (TrackerSparqlConnection*, const gchar*, GCancellable*, GError**)) tracker_remote_connection_real_query;
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	((TrackerSparqlConnectionClass *) klass)->query_async = (void (*) (TrackerSparqlConnection*, const gchar*, GCancellable*, GAsyncReadyCallback, gpointer)) tracker_remote_connection_real_query_async;
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	((TrackerSparqlConnectionClass *) klass)->query_finish = (TrackerSparqlCursor* (*) (TrackerSparqlConnection*, GAsyncResult*, GError**)) tracker_remote_connection_query_finish;
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	((TrackerSparqlConnectionClass *) klass)->close = (void (*) (TrackerSparqlConnection*)) tracker_remote_connection_real_close;
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	((TrackerSparqlConnectionClass *) klass)->close_async = (void (*) (TrackerSparqlConnection*, GAsyncReadyCallback, gpointer)) tracker_remote_connection_real_close_async;
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	((TrackerSparqlConnectionClass *) klass)->close_finish = (gboolean (*) (TrackerSparqlConnection*, GAsyncResult*, GError**)) tracker_remote_connection_close_finish;
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	G_OBJECT_CLASS (klass)->finalize = tracker_remote_connection_finalize;
#line 886 "tracker-remote.c"
}

static void
tracker_remote_connection_instance_init (TrackerRemoteConnection * self,
                                         gpointer klass)
{
}

static void
tracker_remote_connection_finalize (GObject * obj)
{
	TrackerRemoteConnection * self;
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TRACKER_REMOTE_TYPE_CONNECTION, TrackerRemoteConnection);
#line 26 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_g_object_unref0 (self->_session);
#line 27 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_g_free0 (self->_base_uri);
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	G_OBJECT_CLASS (tracker_remote_connection_parent_class)->finalize (obj);
#line 907 "tracker-remote.c"
}

static GType
tracker_remote_connection_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TrackerRemoteConnectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tracker_remote_connection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TrackerRemoteConnection), 0, (GInstanceInitFunc) tracker_remote_connection_instance_init, NULL };
	GType tracker_remote_connection_type_id;
	tracker_remote_connection_type_id = g_type_register_static (TRACKER_SPARQL_TYPE_CONNECTION, "TrackerRemoteConnection", &g_define_type_info, 0);
	return tracker_remote_connection_type_id;
}

GType
tracker_remote_connection_get_type (void)
{
	static volatile gsize tracker_remote_connection_type_id__volatile = 0;
	if (g_once_init_enter (&tracker_remote_connection_type_id__volatile)) {
		GType tracker_remote_connection_type_id;
		tracker_remote_connection_type_id = tracker_remote_connection_get_type_once ();
		g_once_init_leave (&tracker_remote_connection_type_id__volatile, tracker_remote_connection_type_id);
	}
	return tracker_remote_connection_type_id__volatile;
}

