/* tracker-remote.c generated by valac 0.54.6, the Vala compiler
 * generated from tracker-remote.vala, do not modify */

/*
 * Copyright (C) 2016 Carlos Garnacho <carlosg@gnome.org>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA.
 *
 * Author: Carlos Garnacho <carlosg@gnome.org>
 */

#include "tracker-remote-soup3.h"
#include "libtracker-sparql/tracker-sparql.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <glib-object.h>
#include <libsoup/soup.h>

#define TRACKER_REMOTE_CONNECTION_XML_TYPE "application/sparql-results+xml"
#define TRACKER_REMOTE_CONNECTION_JSON_TYPE "application/sparql-results+json"
#define TRACKER_REMOTE_CONNECTION_USER_AGENT "Tracker/" PACKAGE_VERSION " (https://gitlab.gnome.org/GNOME/tracker/issues/; tracker-list@lists.g" \
"nome.org) Tracker/" PACKAGE_VERSION

enum  {
	TRACKER_REMOTE_CONNECTION_0_PROPERTY,
	TRACKER_REMOTE_CONNECTION_NUM_PROPERTIES
};
static GParamSpec* tracker_remote_connection_properties[TRACKER_REMOTE_CONNECTION_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _soup_message_headers_unref0(var) ((var == NULL) ? NULL : (var = (soup_message_headers_unref (var), NULL)))
#define _g_bytes_unref0(var) ((var == NULL) ? NULL : (var = (g_bytes_unref (var), NULL)))
typedef struct _TrackerRemoteConnectionQueryAsyncData TrackerRemoteConnectionQueryAsyncData;
typedef struct _TrackerRemoteConnectionCloseAsyncData TrackerRemoteConnectionCloseAsyncData;

struct _TrackerRemoteConnectionQueryAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	TrackerRemoteConnection* self;
	gchar* sparql;
	GCancellable* cancellable;
	TrackerSparqlCursor* result;
	SoupMessage* message;
	SoupMessage* _tmp0_;
	GBytes* body;
	SoupSession* _tmp1_;
	SoupMessage* _tmp2_;
	GBytes* _tmp3_;
	TrackerSparqlCursor* _tmp4_;
	SoupMessage* _tmp5_;
	GBytes* _tmp6_;
	gsize _tmp7_;
	guint8* _tmp8_;
	TrackerSparqlCursor* _tmp9_;
	TrackerSparqlCursor* _tmp10_;
	GError* _inner_error0_;
};

struct _TrackerRemoteConnectionCloseAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	TrackerRemoteConnection* self;
	gboolean result;
};

static gpointer tracker_remote_connection_parent_class = NULL;

static SoupMessage* tracker_remote_connection_create_request (TrackerRemoteConnection* self,
                                                       const gchar* sparql);
static TrackerSparqlCursor* tracker_remote_connection_create_cursor (TrackerRemoteConnection* self,
                                                              SoupMessage* message,
                                                              const gchar* document,
                                                              GError** error);
static TrackerSparqlCursor* tracker_remote_connection_real_query (TrackerSparqlConnection* base,
                                                           const gchar* sparql,
                                                           GCancellable* cancellable,
                                                           GError** error);
static void tracker_remote_connection_real_query_async_data_free (gpointer _data);
static void tracker_remote_connection_real_query_async (TrackerSparqlConnection* base,
                                                 const gchar* sparql,
                                                 GCancellable* cancellable,
                                                 GAsyncReadyCallback _callback_,
                                                 gpointer _user_data_);
static gboolean tracker_remote_connection_real_query_async_co (TrackerRemoteConnectionQueryAsyncData* _data_);
static void tracker_remote_connection_query_async_ready (GObject* source_object,
                                                  GAsyncResult* _res_,
                                                  gpointer _user_data_);
static void tracker_remote_connection_real_close (TrackerSparqlConnection* base);
static void tracker_remote_connection_real_close_async_data_free (gpointer _data);
static void tracker_remote_connection_real_close_async (TrackerSparqlConnection* base,
                                                 GAsyncReadyCallback _callback_,
                                                 gpointer _user_data_);
static gboolean tracker_remote_connection_real_close_async_co (TrackerRemoteConnectionCloseAsyncData* _data_);
static void tracker_remote_connection_finalize (GObject * obj);
static GType tracker_remote_connection_get_type_once (void);

TrackerRemoteConnection*
tracker_remote_connection_construct (GType object_type,
                                     const gchar* base_uri)
{
	TrackerRemoteConnection * self = NULL;
	gchar* _tmp0_;
	SoupSession* _tmp1_;
#line 33 "../src/libtracker-sparql/remote/tracker-remote.vala"
	g_return_val_if_fail (base_uri != NULL, NULL);
#line 34 "../src/libtracker-sparql/remote/tracker-remote.vala"
	self = (TrackerRemoteConnection*) g_object_new (object_type, NULL);
#line 35 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp0_ = g_strdup (base_uri);
#line 35 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_g_free0 (self->_base_uri);
#line 35 "../src/libtracker-sparql/remote/tracker-remote.vala"
	self->_base_uri = _tmp0_;
#line 36 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp1_ = soup_session_new ();
#line 36 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_g_object_unref0 (self->_session);
#line 36 "../src/libtracker-sparql/remote/tracker-remote.vala"
	self->_session = _tmp1_;
#line 33 "../src/libtracker-sparql/remote/tracker-remote.vala"
	return self;
#line 141 "tracker-remote.c"
}

TrackerRemoteConnection*
tracker_remote_connection_new (const gchar* base_uri)
{
#line 33 "../src/libtracker-sparql/remote/tracker-remote.vala"
	return tracker_remote_connection_construct (TRACKER_REMOTE_TYPE_CONNECTION, base_uri);
#line 149 "tracker-remote.c"
}

static gpointer
_soup_message_headers_ref0 (gpointer self)
{
#line 45 "../src/libtracker-sparql/remote/tracker-remote.vala"
	return self ? soup_message_headers_ref (self) : NULL;
#line 157 "tracker-remote.c"
}

static SoupMessage*
tracker_remote_connection_create_request (TrackerRemoteConnection* self,
                                          const gchar* sparql)
{
	gchar* uri = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	SoupMessage* message = NULL;
	SoupMessage* _tmp5_;
	SoupMessageHeaders* headers = NULL;
	SoupMessageHeaders* _tmp6_;
	SoupMessageHeaders* _tmp7_;
	SoupMessage* result = NULL;
#line 39 "../src/libtracker-sparql/remote/tracker-remote.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 39 "../src/libtracker-sparql/remote/tracker-remote.vala"
	g_return_val_if_fail (sparql != NULL, NULL);
#line 40 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp0_ = self->_base_uri;
#line 40 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp1_ = g_strconcat (_tmp0_, "?query=", NULL);
#line 40 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp2_ = _tmp1_;
#line 40 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp3_ = g_strconcat (_tmp2_, sparql, NULL);
#line 40 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp4_ = _tmp3_;
#line 40 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_g_free0 (_tmp2_);
#line 40 "../src/libtracker-sparql/remote/tracker-remote.vala"
	uri = _tmp4_;
#line 41 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp5_ = soup_message_new ("GET", uri);
#line 41 "../src/libtracker-sparql/remote/tracker-remote.vala"
	message = _tmp5_;
#line 45 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp6_ = soup_message_get_request_headers (message);
#line 45 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp7_ = _soup_message_headers_ref0 (_tmp6_);
#line 45 "../src/libtracker-sparql/remote/tracker-remote.vala"
	headers = _tmp7_;
#line 48 "../src/libtracker-sparql/remote/tracker-remote.vala"
	soup_message_headers_append (headers, "User-Agent", TRACKER_REMOTE_CONNECTION_USER_AGENT);
#line 49 "../src/libtracker-sparql/remote/tracker-remote.vala"
	soup_message_headers_append (headers, "Accept", TRACKER_REMOTE_CONNECTION_JSON_TYPE);
#line 50 "../src/libtracker-sparql/remote/tracker-remote.vala"
	soup_message_headers_append (headers, "Accept", TRACKER_REMOTE_CONNECTION_XML_TYPE);
#line 52 "../src/libtracker-sparql/remote/tracker-remote.vala"
	result = message;
#line 52 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_soup_message_headers_unref0 (headers);
#line 52 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_g_free0 (uri);
#line 52 "../src/libtracker-sparql/remote/tracker-remote.vala"
	return result;
#line 218 "tracker-remote.c"
}

static TrackerSparqlCursor*
tracker_remote_connection_create_cursor (TrackerRemoteConnection* self,
                                         SoupMessage* message,
                                         const gchar* document,
                                         GError** error)
{
	SoupStatus status_code = 0;
	SoupMessageHeaders* headers = NULL;
	SoupMessageHeaders* _tmp0_;
	SoupMessageHeaders* _tmp1_;
	gchar* content_type = NULL;
	SoupMessageHeaders* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	glong length = 0L;
	gint _tmp6_;
	gint _tmp7_;
	const gchar* _tmp8_;
	GError* _inner_error0_ = NULL;
	TrackerSparqlCursor* result = NULL;
#line 55 "../src/libtracker-sparql/remote/tracker-remote.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 55 "../src/libtracker-sparql/remote/tracker-remote.vala"
	g_return_val_if_fail (message != NULL, NULL);
#line 55 "../src/libtracker-sparql/remote/tracker-remote.vala"
	g_return_val_if_fail (document != NULL, NULL);
#line 60 "../src/libtracker-sparql/remote/tracker-remote.vala"
	status_code = soup_message_get_status (message);
#line 61 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp0_ = soup_message_get_response_headers (message);
#line 61 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp1_ = _soup_message_headers_ref0 (_tmp0_);
#line 61 "../src/libtracker-sparql/remote/tracker-remote.vala"
	headers = _tmp1_;
#line 64 "../src/libtracker-sparql/remote/tracker-remote.vala"
	if (status_code != SOUP_STATUS_OK) {
#line 257 "tracker-remote.c"
		GError* _tmp2_;
#line 65 "../src/libtracker-sparql/remote/tracker-remote.vala"
		_tmp2_ = g_error_new (TRACKER_SPARQL_ERROR, TRACKER_SPARQL_ERROR_UNSUPPORTED, "Unhandled status code %u, document is: %s", (guint) status_code, document);
#line 65 "../src/libtracker-sparql/remote/tracker-remote.vala"
		_inner_error0_ = _tmp2_;
#line 65 "../src/libtracker-sparql/remote/tracker-remote.vala"
		g_propagate_error (error, _inner_error0_);
#line 65 "../src/libtracker-sparql/remote/tracker-remote.vala"
		_soup_message_headers_unref0 (headers);
#line 65 "../src/libtracker-sparql/remote/tracker-remote.vala"
		return NULL;
#line 269 "tracker-remote.c"
	}
#line 69 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp3_ = headers;
#line 69 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp4_ = soup_message_headers_get_content_type (_tmp3_, NULL);
#line 69 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 69 "../src/libtracker-sparql/remote/tracker-remote.vala"
	content_type = _tmp5_;
#line 70 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp6_ = strlen (document);
#line 70 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp7_ = _tmp6_;
#line 70 "../src/libtracker-sparql/remote/tracker-remote.vala"
	length = (glong) _tmp7_;
#line 72 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp8_ = content_type;
#line 72 "../src/libtracker-sparql/remote/tracker-remote.vala"
	if (g_strcmp0 (_tmp8_, TRACKER_REMOTE_CONNECTION_JSON_TYPE) == 0) {
#line 289 "tracker-remote.c"
		TrackerRemoteJsonCursor* _tmp9_ = NULL;
		TrackerRemoteJsonCursor* _tmp10_;
		TrackerRemoteJsonCursor* _tmp11_;
#line 73 "../src/libtracker-sparql/remote/tracker-remote.vala"
		_tmp10_ = tracker_remote_json_cursor_new (document, length, &_inner_error0_);
#line 73 "../src/libtracker-sparql/remote/tracker-remote.vala"
		_tmp9_ = _tmp10_;
#line 73 "../src/libtracker-sparql/remote/tracker-remote.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 73 "../src/libtracker-sparql/remote/tracker-remote.vala"
			g_propagate_error (error, _inner_error0_);
#line 73 "../src/libtracker-sparql/remote/tracker-remote.vala"
			_g_free0 (content_type);
#line 73 "../src/libtracker-sparql/remote/tracker-remote.vala"
			_soup_message_headers_unref0 (headers);
#line 73 "../src/libtracker-sparql/remote/tracker-remote.vala"
			return NULL;
#line 307 "tracker-remote.c"
		}
#line 73 "../src/libtracker-sparql/remote/tracker-remote.vala"
		_tmp11_ = _tmp9_;
#line 73 "../src/libtracker-sparql/remote/tracker-remote.vala"
		_tmp9_ = NULL;
#line 73 "../src/libtracker-sparql/remote/tracker-remote.vala"
		result = (TrackerSparqlCursor*) _tmp11_;
#line 73 "../src/libtracker-sparql/remote/tracker-remote.vala"
		_g_object_unref0 (_tmp9_);
#line 73 "../src/libtracker-sparql/remote/tracker-remote.vala"
		_g_free0 (content_type);
#line 73 "../src/libtracker-sparql/remote/tracker-remote.vala"
		_soup_message_headers_unref0 (headers);
#line 73 "../src/libtracker-sparql/remote/tracker-remote.vala"
		return result;
#line 323 "tracker-remote.c"
	} else {
		const gchar* _tmp12_;
#line 74 "../src/libtracker-sparql/remote/tracker-remote.vala"
		_tmp12_ = content_type;
#line 74 "../src/libtracker-sparql/remote/tracker-remote.vala"
		if (g_strcmp0 (_tmp12_, TRACKER_REMOTE_CONNECTION_XML_TYPE) == 0) {
#line 330 "tracker-remote.c"
			TrackerRemoteXmlCursor* _tmp13_ = NULL;
			TrackerRemoteXmlCursor* _tmp14_;
			TrackerRemoteXmlCursor* _tmp15_;
#line 75 "../src/libtracker-sparql/remote/tracker-remote.vala"
			_tmp14_ = tracker_remote_xml_cursor_new (document, length, &_inner_error0_);
#line 75 "../src/libtracker-sparql/remote/tracker-remote.vala"
			_tmp13_ = _tmp14_;
#line 75 "../src/libtracker-sparql/remote/tracker-remote.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 75 "../src/libtracker-sparql/remote/tracker-remote.vala"
				g_propagate_error (error, _inner_error0_);
#line 75 "../src/libtracker-sparql/remote/tracker-remote.vala"
				_g_free0 (content_type);
#line 75 "../src/libtracker-sparql/remote/tracker-remote.vala"
				_soup_message_headers_unref0 (headers);
#line 75 "../src/libtracker-sparql/remote/tracker-remote.vala"
				return NULL;
#line 348 "tracker-remote.c"
			}
#line 75 "../src/libtracker-sparql/remote/tracker-remote.vala"
			_tmp15_ = _tmp13_;
#line 75 "../src/libtracker-sparql/remote/tracker-remote.vala"
			_tmp13_ = NULL;
#line 75 "../src/libtracker-sparql/remote/tracker-remote.vala"
			result = (TrackerSparqlCursor*) _tmp15_;
#line 75 "../src/libtracker-sparql/remote/tracker-remote.vala"
			_g_object_unref0 (_tmp13_);
#line 75 "../src/libtracker-sparql/remote/tracker-remote.vala"
			_g_free0 (content_type);
#line 75 "../src/libtracker-sparql/remote/tracker-remote.vala"
			_soup_message_headers_unref0 (headers);
#line 75 "../src/libtracker-sparql/remote/tracker-remote.vala"
			return result;
#line 364 "tracker-remote.c"
		} else {
			const gchar* _tmp16_;
			GError* _tmp17_;
#line 77 "../src/libtracker-sparql/remote/tracker-remote.vala"
			_tmp16_ = content_type;
#line 77 "../src/libtracker-sparql/remote/tracker-remote.vala"
			_tmp17_ = g_error_new (TRACKER_SPARQL_ERROR, TRACKER_SPARQL_ERROR_UNSUPPORTED, "Unknown content type '%s', document is: %s", _tmp16_, document);
#line 77 "../src/libtracker-sparql/remote/tracker-remote.vala"
			_inner_error0_ = _tmp17_;
#line 77 "../src/libtracker-sparql/remote/tracker-remote.vala"
			g_propagate_error (error, _inner_error0_);
#line 77 "../src/libtracker-sparql/remote/tracker-remote.vala"
			_g_free0 (content_type);
#line 77 "../src/libtracker-sparql/remote/tracker-remote.vala"
			_soup_message_headers_unref0 (headers);
#line 77 "../src/libtracker-sparql/remote/tracker-remote.vala"
			return NULL;
#line 382 "tracker-remote.c"
		}
	}
}

static TrackerSparqlCursor*
tracker_remote_connection_real_query (TrackerSparqlConnection* base,
                                      const gchar* sparql,
                                      GCancellable* cancellable,
                                      GError** error)
{
	TrackerRemoteConnection * self;
	SoupMessage* message = NULL;
	SoupMessage* _tmp0_;
	GBytes* body = NULL;
	SoupSession* _tmp1_;
	SoupMessage* _tmp2_;
	GBytes* _tmp3_;
	gboolean _tmp4_ = FALSE;
	TrackerSparqlCursor* _tmp6_ = NULL;
	SoupMessage* _tmp7_;
	GBytes* _tmp8_;
	gsize _tmp9_ = 0;
	guint8* _tmp10_;
	TrackerSparqlCursor* _tmp11_;
	TrackerSparqlCursor* _tmp12_;
	GError* _inner_error0_ = NULL;
	TrackerSparqlCursor* result = NULL;
#line 81 "../src/libtracker-sparql/remote/tracker-remote.vala"
	self = (TrackerRemoteConnection*) base;
#line 81 "../src/libtracker-sparql/remote/tracker-remote.vala"
	g_return_val_if_fail (sparql != NULL, NULL);
#line 82 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp0_ = tracker_remote_connection_create_request (self, sparql);
#line 82 "../src/libtracker-sparql/remote/tracker-remote.vala"
	message = _tmp0_;
#line 87 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp1_ = self->_session;
#line 87 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp2_ = message;
#line 87 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp3_ = soup_session_send_and_read (_tmp1_, _tmp2_, NULL, &_inner_error0_);
#line 87 "../src/libtracker-sparql/remote/tracker-remote.vala"
	body = _tmp3_;
#line 87 "../src/libtracker-sparql/remote/tracker-remote.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 87 "../src/libtracker-sparql/remote/tracker-remote.vala"
		g_propagate_error (error, _inner_error0_);
#line 87 "../src/libtracker-sparql/remote/tracker-remote.vala"
		_g_object_unref0 (message);
#line 87 "../src/libtracker-sparql/remote/tracker-remote.vala"
		return NULL;
#line 434 "tracker-remote.c"
	}
#line 90 "../src/libtracker-sparql/remote/tracker-remote.vala"
	if (cancellable != NULL) {
#line 90 "../src/libtracker-sparql/remote/tracker-remote.vala"
		_tmp4_ = g_cancellable_is_cancelled (cancellable);
#line 440 "tracker-remote.c"
	} else {
#line 90 "../src/libtracker-sparql/remote/tracker-remote.vala"
		_tmp4_ = FALSE;
#line 444 "tracker-remote.c"
	}
#line 90 "../src/libtracker-sparql/remote/tracker-remote.vala"
	if (_tmp4_) {
#line 448 "tracker-remote.c"
		GError* _tmp5_;
#line 91 "../src/libtracker-sparql/remote/tracker-remote.vala"
		_tmp5_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_CANCELLED, "Operation was cancelled");
#line 91 "../src/libtracker-sparql/remote/tracker-remote.vala"
		_inner_error0_ = _tmp5_;
#line 91 "../src/libtracker-sparql/remote/tracker-remote.vala"
		g_propagate_error (error, _inner_error0_);
#line 91 "../src/libtracker-sparql/remote/tracker-remote.vala"
		_g_bytes_unref0 (body);
#line 91 "../src/libtracker-sparql/remote/tracker-remote.vala"
		_g_object_unref0 (message);
#line 91 "../src/libtracker-sparql/remote/tracker-remote.vala"
		return NULL;
#line 462 "tracker-remote.c"
	}
#line 96 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp7_ = message;
#line 96 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp8_ = body;
#line 96 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp10_ = g_bytes_get_data (_tmp8_, &_tmp9_);
#line 96 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp11_ = tracker_remote_connection_create_cursor (self, _tmp7_, (const gchar*) _tmp10_, &_inner_error0_);
#line 96 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp6_ = _tmp11_;
#line 96 "../src/libtracker-sparql/remote/tracker-remote.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 96 "../src/libtracker-sparql/remote/tracker-remote.vala"
		g_propagate_error (error, _inner_error0_);
#line 96 "../src/libtracker-sparql/remote/tracker-remote.vala"
		_g_bytes_unref0 (body);
#line 96 "../src/libtracker-sparql/remote/tracker-remote.vala"
		_g_object_unref0 (message);
#line 96 "../src/libtracker-sparql/remote/tracker-remote.vala"
		return NULL;
#line 484 "tracker-remote.c"
	}
#line 96 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp12_ = _tmp6_;
#line 96 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp6_ = NULL;
#line 96 "../src/libtracker-sparql/remote/tracker-remote.vala"
	result = _tmp12_;
#line 96 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_g_object_unref0 (_tmp6_);
#line 96 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_g_bytes_unref0 (body);
#line 96 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_g_object_unref0 (message);
#line 96 "../src/libtracker-sparql/remote/tracker-remote.vala"
	return result;
#line 500 "tracker-remote.c"
}

static void
tracker_remote_connection_real_query_async_data_free (gpointer _data)
{
	TrackerRemoteConnectionQueryAsyncData* _data_;
	_data_ = _data;
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_g_free0 (_data_->sparql);
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_g_object_unref0 (_data_->result);
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	g_slice_free (TrackerRemoteConnectionQueryAsyncData, _data_);
#line 518 "tracker-remote.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	return self ? g_object_ref (self) : NULL;
#line 526 "tracker-remote.c"
}

static void
tracker_remote_connection_real_query_async (TrackerSparqlConnection* base,
                                            const gchar* sparql,
                                            GCancellable* cancellable,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_)
{
	TrackerRemoteConnection * self;
	TrackerRemoteConnectionQueryAsyncData* _data_;
	TrackerRemoteConnection* _tmp0_;
	gchar* _tmp1_;
	GCancellable* _tmp2_;
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	g_return_if_fail (sparql != NULL);
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	self = (TrackerRemoteConnection*) base;
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_ = g_slice_new0 (TrackerRemoteConnectionQueryAsyncData);
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	g_task_set_task_data (_data_->_async_result, _data_, tracker_remote_connection_real_query_async_data_free);
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_->self = _tmp0_;
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp1_ = g_strdup (sparql);
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_g_free0 (_data_->sparql);
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_->sparql = _tmp1_;
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_->cancellable = _tmp2_;
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	tracker_remote_connection_real_query_async_co (_data_);
#line 569 "tracker-remote.c"
}

static TrackerSparqlCursor*
tracker_remote_connection_query_finish (TrackerSparqlConnection* base,
                                        GAsyncResult* _res_,
                                        GError** error)
{
	TrackerSparqlCursor* result;
	TrackerRemoteConnectionQueryAsyncData* _data_;
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	if (NULL == _data_) {
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
		return NULL;
#line 585 "tracker-remote.c"
	}
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	result = _data_->result;
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_->result = NULL;
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	return result;
#line 593 "tracker-remote.c"
}

static void
tracker_remote_connection_query_async_ready (GObject* source_object,
                                             GAsyncResult* _res_,
                                             gpointer _user_data_)
{
	TrackerRemoteConnectionQueryAsyncData* _data_;
#line 107 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_ = _user_data_;
#line 107 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_->_source_object_ = source_object;
#line 107 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_->_res_ = _res_;
#line 107 "../src/libtracker-sparql/remote/tracker-remote.vala"
	tracker_remote_connection_real_query_async_co (_data_);
#line 610 "tracker-remote.c"
}

static gboolean
tracker_remote_connection_real_query_async_co (TrackerRemoteConnectionQueryAsyncData* _data_)
{
#line 100 "../src/libtracker-sparql/remote/tracker-remote.vala"
	switch (_data_->_state_) {
#line 100 "../src/libtracker-sparql/remote/tracker-remote.vala"
		case 0:
#line 620 "tracker-remote.c"
		goto _state_0;
#line 100 "../src/libtracker-sparql/remote/tracker-remote.vala"
		case 1:
#line 624 "tracker-remote.c"
		goto _state_1;
		default:
#line 100 "../src/libtracker-sparql/remote/tracker-remote.vala"
		g_assert_not_reached ();
#line 629 "tracker-remote.c"
	}
	_state_0:
#line 101 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_->_tmp0_ = tracker_remote_connection_create_request (_data_->self, _data_->sparql);
#line 101 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_->message = _data_->_tmp0_;
#line 107 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_->_tmp1_ = _data_->self->_session;
#line 107 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_->_tmp2_ = _data_->message;
#line 107 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_->_state_ = 1;
#line 107 "../src/libtracker-sparql/remote/tracker-remote.vala"
	soup_session_send_and_read_async (_data_->_tmp1_, _data_->_tmp2_, G_PRIORITY_DEFAULT, _data_->cancellable, tracker_remote_connection_query_async_ready, _data_);
#line 107 "../src/libtracker-sparql/remote/tracker-remote.vala"
	return FALSE;
#line 646 "tracker-remote.c"
	_state_1:
#line 107 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_->_tmp3_ = soup_session_send_and_read_finish (_data_->_tmp1_, _data_->_res_, &_data_->_inner_error0_);
#line 107 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_->body = _data_->_tmp3_;
#line 107 "../src/libtracker-sparql/remote/tracker-remote.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 107 "../src/libtracker-sparql/remote/tracker-remote.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 107 "../src/libtracker-sparql/remote/tracker-remote.vala"
		_g_object_unref0 (_data_->message);
#line 107 "../src/libtracker-sparql/remote/tracker-remote.vala"
		g_object_unref (_data_->_async_result);
#line 107 "../src/libtracker-sparql/remote/tracker-remote.vala"
		return FALSE;
#line 662 "tracker-remote.c"
	}
#line 108 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_->_tmp5_ = _data_->message;
#line 108 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_->_tmp6_ = _data_->body;
#line 108 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_->_tmp7_ = 0;
#line 108 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_->_tmp8_ = g_bytes_get_data (_data_->_tmp6_, &_data_->_tmp7_);
#line 108 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_->_tmp9_ = tracker_remote_connection_create_cursor (_data_->self, _data_->_tmp5_, (const gchar*) _data_->_tmp8_, &_data_->_inner_error0_);
#line 108 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_->_tmp4_ = _data_->_tmp9_;
#line 108 "../src/libtracker-sparql/remote/tracker-remote.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 108 "../src/libtracker-sparql/remote/tracker-remote.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 108 "../src/libtracker-sparql/remote/tracker-remote.vala"
		_g_bytes_unref0 (_data_->body);
#line 108 "../src/libtracker-sparql/remote/tracker-remote.vala"
		_g_object_unref0 (_data_->message);
#line 108 "../src/libtracker-sparql/remote/tracker-remote.vala"
		g_object_unref (_data_->_async_result);
#line 108 "../src/libtracker-sparql/remote/tracker-remote.vala"
		return FALSE;
#line 688 "tracker-remote.c"
	}
#line 108 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_->_tmp10_ = _data_->_tmp4_;
#line 108 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_->_tmp4_ = NULL;
#line 108 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_->result = _data_->_tmp10_;
#line 108 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_g_object_unref0 (_data_->_tmp4_);
#line 108 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_g_bytes_unref0 (_data_->body);
#line 108 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_g_object_unref0 (_data_->message);
#line 108 "../src/libtracker-sparql/remote/tracker-remote.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 108 "../src/libtracker-sparql/remote/tracker-remote.vala"
	if (_data_->_state_ != 0) {
#line 108 "../src/libtracker-sparql/remote/tracker-remote.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 108 "../src/libtracker-sparql/remote/tracker-remote.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 710 "tracker-remote.c"
		}
	}
#line 108 "../src/libtracker-sparql/remote/tracker-remote.vala"
	g_object_unref (_data_->_async_result);
#line 108 "../src/libtracker-sparql/remote/tracker-remote.vala"
	return FALSE;
#line 717 "tracker-remote.c"
}

static void
tracker_remote_connection_real_close (TrackerSparqlConnection* base)
{
	TrackerRemoteConnection * self;
#line 112 "../src/libtracker-sparql/remote/tracker-remote.vala"
	self = (TrackerRemoteConnection*) base;
#line 726 "tracker-remote.c"
}

static void
tracker_remote_connection_real_close_async_data_free (gpointer _data)
{
	TrackerRemoteConnectionCloseAsyncData* _data_;
	_data_ = _data;
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	g_slice_free (TrackerRemoteConnectionCloseAsyncData, _data_);
#line 738 "tracker-remote.c"
}

static void
tracker_remote_connection_real_close_async (TrackerSparqlConnection* base,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_)
{
	TrackerRemoteConnection * self;
	TrackerRemoteConnectionCloseAsyncData* _data_;
	TrackerRemoteConnection* _tmp0_;
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	self = (TrackerRemoteConnection*) base;
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_ = g_slice_new0 (TrackerRemoteConnectionCloseAsyncData);
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	g_task_set_task_data (_data_->_async_result, _data_, tracker_remote_connection_real_close_async_data_free);
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_->self = _tmp0_;
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	tracker_remote_connection_real_close_async_co (_data_);
#line 763 "tracker-remote.c"
}

static gboolean
tracker_remote_connection_close_finish (TrackerSparqlConnection* base,
                                        GAsyncResult* _res_,
                                        GError** error)
{
	gboolean result;
	TrackerRemoteConnectionCloseAsyncData* _data_;
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	if (NULL == _data_) {
#line 777 "tracker-remote.c"
		gboolean _tmp0_ = FALSE;
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
		return _tmp0_;
#line 781 "tracker-remote.c"
	}
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	result = _data_->result;
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	return result;
#line 787 "tracker-remote.c"
}

static gboolean
tracker_remote_connection_real_close_async_co (TrackerRemoteConnectionCloseAsyncData* _data_)
{
#line 115 "../src/libtracker-sparql/remote/tracker-remote.vala"
	switch (_data_->_state_) {
#line 115 "../src/libtracker-sparql/remote/tracker-remote.vala"
		case 0:
#line 797 "tracker-remote.c"
		goto _state_0;
		default:
#line 115 "../src/libtracker-sparql/remote/tracker-remote.vala"
		g_assert_not_reached ();
#line 802 "tracker-remote.c"
	}
	_state_0:
#line 116 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_data_->result = TRUE;
#line 116 "../src/libtracker-sparql/remote/tracker-remote.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 116 "../src/libtracker-sparql/remote/tracker-remote.vala"
	if (_data_->_state_ != 0) {
#line 116 "../src/libtracker-sparql/remote/tracker-remote.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 116 "../src/libtracker-sparql/remote/tracker-remote.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 815 "tracker-remote.c"
		}
	}
#line 116 "../src/libtracker-sparql/remote/tracker-remote.vala"
	g_object_unref (_data_->_async_result);
#line 116 "../src/libtracker-sparql/remote/tracker-remote.vala"
	return FALSE;
#line 822 "tracker-remote.c"
}

static void
tracker_remote_connection_class_init (TrackerRemoteConnectionClass * klass,
                                      gpointer klass_data)
{
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	tracker_remote_connection_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	((TrackerSparqlConnectionClass *) klass)->query = (TrackerSparqlCursor* (*) (TrackerSparqlConnection*, const gchar*, GCancellable*, GError**)) tracker_remote_connection_real_query;
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	((TrackerSparqlConnectionClass *) klass)->query_async = (void (*) (TrackerSparqlConnection*, const gchar*, GCancellable*, GAsyncReadyCallback, gpointer)) tracker_remote_connection_real_query_async;
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	((TrackerSparqlConnectionClass *) klass)->query_finish = (TrackerSparqlCursor* (*) (TrackerSparqlConnection*, GAsyncResult*, GError**)) tracker_remote_connection_query_finish;
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	((TrackerSparqlConnectionClass *) klass)->close = (void (*) (TrackerSparqlConnection*)) tracker_remote_connection_real_close;
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	((TrackerSparqlConnectionClass *) klass)->close_async = (void (*) (TrackerSparqlConnection*, GAsyncReadyCallback, gpointer)) tracker_remote_connection_real_close_async;
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	((TrackerSparqlConnectionClass *) klass)->close_finish = (gboolean (*) (TrackerSparqlConnection*, GAsyncResult*, GError**)) tracker_remote_connection_close_finish;
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	G_OBJECT_CLASS (klass)->finalize = tracker_remote_connection_finalize;
#line 845 "tracker-remote.c"
}

static void
tracker_remote_connection_instance_init (TrackerRemoteConnection * self,
                                         gpointer klass)
{
}

static void
tracker_remote_connection_finalize (GObject * obj)
{
	TrackerRemoteConnection * self;
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TRACKER_REMOTE_TYPE_CONNECTION, TrackerRemoteConnection);
#line 26 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_g_object_unref0 (self->_session);
#line 27 "../src/libtracker-sparql/remote/tracker-remote.vala"
	_g_free0 (self->_base_uri);
#line 24 "../src/libtracker-sparql/remote/tracker-remote.vala"
	G_OBJECT_CLASS (tracker_remote_connection_parent_class)->finalize (obj);
#line 866 "tracker-remote.c"
}

static GType
tracker_remote_connection_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TrackerRemoteConnectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tracker_remote_connection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TrackerRemoteConnection), 0, (GInstanceInitFunc) tracker_remote_connection_instance_init, NULL };
	GType tracker_remote_connection_type_id;
	tracker_remote_connection_type_id = g_type_register_static (TRACKER_SPARQL_TYPE_CONNECTION, "TrackerRemoteConnection", &g_define_type_info, 0);
	return tracker_remote_connection_type_id;
}

GType
tracker_remote_connection_get_type (void)
{
	static volatile gsize tracker_remote_connection_type_id__volatile = 0;
	if (g_once_init_enter (&tracker_remote_connection_type_id__volatile)) {
		GType tracker_remote_connection_type_id;
		tracker_remote_connection_type_id = tracker_remote_connection_get_type_once ();
		g_once_init_leave (&tracker_remote_connection_type_id__volatile, tracker_remote_connection_type_id);
	}
	return tracker_remote_connection_type_id__volatile;
}

